"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlCheckList = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var Check_1 = __importDefault(require("@mui/icons-material/Check"));
var theme_1 = require("./theme");
var Markdown_1 = require("./tools/Markdown");
var theme_2 = require("./theme");
exports.GlCheckList = react_1.memo(function (props) {
    var className = props.className, elements = props.elements, heading = props.heading, subHeading = props.subHeading, classesProp = props.classes;
    var _a = useStyles({
        "numberOfElements": elements === undefined ? 1 : elements.length,
    }), classes = _a.classes, cx = _a.cx;
    return (jsx_runtime_1.jsxs("section", __assign({ className: cx(classes.root, className) }, { children: [(heading !== undefined || subHeading !== undefined) && (jsx_runtime_1.jsxs("div", __assign({ className: cx(classes.headingWrapper, classesProp === null || classesProp === void 0 ? void 0 : classesProp.headingWrapper) }, { children: [heading !== undefined && (jsx_runtime_1.jsx(theme_1.Text, __assign({ className: cx(classes.heading, classesProp === null || classesProp === void 0 ? void 0 : classesProp.heading), typo: "section heading" }, { children: heading }), void 0)),
                    subHeading !== undefined && (jsx_runtime_1.jsx(Markdown_1.Markdown, __assign({ className: cx(classes.subHeading, classesProp === null || classesProp === void 0 ? void 0 : classesProp.subHeading) }, { children: subHeading }), void 0))] }), void 0)),
            jsx_runtime_1.jsx("div", __assign({ className: cx(classes.elements, classesProp === null || classesProp === void 0 ? void 0 : classesProp.elements) }, { children: elements !== undefined &&
                    elements.map(function (elementProps) { return (jsx_runtime_1.jsx(CheckListElement, __assign({ className: classesProp === null || classesProp === void 0 ? void 0 : classesProp.element, classes: {
                            "checkIcon": classesProp === null || classesProp === void 0 ? void 0 : classesProp.checkIcon,
                            "checkIconWrapper": classesProp === null || classesProp === void 0 ? void 0 : classesProp.checkIconWrapper,
                            "description": classesProp === null || classesProp === void 0 ? void 0 : classesProp.elementDescription,
                            "title": classesProp === null || classesProp === void 0 ? void 0 : classesProp.elementTitle,
                            "titleAndDescriptionWrapper": classesProp === null || classesProp === void 0 ? void 0 : classesProp.elementTitleAndDescriptionWrapper,
                        } }, elementProps), elementProps.description)); }) }), void 0)] }), void 0));
});
var useStyles = theme_2.makeStyles()(function (theme, _a) {
    var numberOfElements = _a.numberOfElements;
    return ({
        "root": {
            "display": "flex",
            "flexDirection": "column",
            "alignItems": "center",
        },
        "heading": {
            "fontSize": "2rem",
        },
        "headingWrapper": {
            "marginBottom": theme.spacing(6),
            "display": "flex",
            "flexDirection": "column",
            "alignItems": "center",
        },
        "elements": {
            "display": "grid",
            "gridTemplateColumns": "repeat(" + (function () {
                if (theme.windowInnerWidth >= theme_2.breakpointsValues.lg) {
                    if (numberOfElements >= 3) {
                        return 3;
                    }
                    return numberOfElements;
                }
                if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                    if (numberOfElements >= 2) {
                        return 2;
                    }
                    return 1;
                }
                return 1;
            })() + ", 1fr)",
            "gap": theme.spacing(6),
        },
        "subHeading": __assign(__assign({}, theme.typography.variants["body 1"].style), { "color": theme.colors.useCases.typography.textSecondary }),
    });
});
var CheckListElement = (function () {
    var CheckListElement = react_1.memo(function (props) {
        var description = props.description, title = props.title, className = props.className, classesProp = props.classes;
        var _a = useStyles(), classes = _a.classes, cx = _a.cx;
        return (jsx_runtime_1.jsxs("div", __assign({ className: cx(classes.root, className) }, { children: [jsx_runtime_1.jsx("div", __assign({ className: cx(classes.CheckIcon, classesProp === null || classesProp === void 0 ? void 0 : classesProp.checkIconWrapper) }, { children: jsx_runtime_1.jsx(Check_1.default, { className: classesProp === null || classesProp === void 0 ? void 0 : classesProp.checkIcon, color: "success" }, void 0) }), void 0),
                jsx_runtime_1.jsxs("div", __assign({ className: classesProp === null || classesProp === void 0 ? void 0 : classesProp.titleAndDescriptionWrapper }, { children: [title !== undefined && (jsx_runtime_1.jsx(Markdown_1.Markdown, __assign({ className: cx(classes.title, classesProp === null || classesProp === void 0 ? void 0 : classesProp.title) }, { children: title }), void 0)),
                        jsx_runtime_1.jsx(Markdown_1.Markdown, __assign({ className: cx(classes.description, classesProp === null || classesProp === void 0 ? void 0 : classesProp.description) }, { children: description }), void 0)] }), void 0)] }), void 0));
    });
    var useStyles = theme_2.makeStyles()(function (theme) { return ({
        "root": {
            "width": theme.windowInnerWidth >= theme_2.breakpointsValues.sm
                ? 300
                : undefined,
            "display": "flex",
        },
        "CheckIcon": {
            "paddingTop": theme.spacing(3.5),
            "marginRight": theme.spacing(3),
        },
        "description": __assign({ "color": theme.colors.useCases.typography.textSecondary }, theme.typography.variants["body 1"].style),
        "title": __assign({}, theme.typography.variants["object heading"].style),
    }); });
    return { CheckListElement: CheckListElement };
})().CheckListElement;
//# sourceMappingURL=GlCheckList.js.map